unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, SynEdit;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SynEdit1: TSynEdit;
    SynEdit2: TSynEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FFullText: String;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Button1.Enabled := false;
  Button2.Enabled := true;
  SynEdit2.ShareTextBufferFrom(SynEdit1);
  SynEdit2.Invalidate;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Button1.Enabled := true;
  Button2.Enabled := false;
  SynEdit2.UnShareTextBuffer;
  SynEdit2.Invalidate;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SynEdit1.Text := FFullText;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1.Enabled := true;
  Button2.Enabled := false;
  FFullText := SynEdit1.Text;
end;

end.

